## ros-ardent-class-loader 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(class_loader)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

set(CLASS_LOADER_IGNORE_AMENT FALSE CACHE BOOL
  "Do not use ament when building this package.")
if(NOT CLASS_LOADER_IGNORE_AMENT)
  find_package(ament_cmake)
endif()

find_package(console_bridge REQUIRED)
find_package(poco_vendor REQUIRED)  # Provides FindPoco.cmake and Poco on platforms without it.
find_package(Poco REQUIRED COMPONENTS Foundation)
link_directories(${Poco_LIBRARY_DIR})

if(ament_cmake_FOUND)
  ament_export_dependencies(console_bridge)
  ament_export_include_directories(include)
  ament_export_libraries(${PROJECT_NAME})
endif()

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SRCS})
target_include_directories(${PROJECT_NAME}
  PUBLIC include ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

if(ament_cmake_FOUND)
  ament_package(
    CONFIG_EXTRAS "class_loader-extras.cmake"
  )
else()
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${console_bridge_LIBRARIES}
    ${Poco_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/${PROJECT_NAME}.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY)

  install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc" DESTINATION lib/pkgconfig)
endif()

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY include/${PROJECT_NAME}
  DESTINATION include)

=== .travis/Makefile ===
all: class_loader

UNAME := $(shell uname -s)

install_deps:
ifeq ($(UNAME),Darwin)
	brew update
	brew outdated python3 || brew upgrade python3 || brew install python3
	brew outdated poco || brew upgrade poco || brew install poco
	sudo -H python3 -m pip install -U empy pyparsing
else
	sudo sh -c 'echo "deb http://packages.ros.org/ros/ubuntu trusty main" > /etc/apt/sources.list.d/ros-latest.list'
	wget http://packages.ros.org/ros.key -O - | sudo apt-key add -
	sudo apt-get update -qq
	sudo apt-get install cmake python3 python3-pip python3-empy python3-pyparsing python3-setuptools wget libpoco-dev
	sudo -H python3 -m pip install -U pyparsing
endif
	python3 --version

=== debian/changelog ===
ros-ardent-class-loader (1.0.0-13xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mikael Arguedas <mikael@osrfoundation.org>  Sat, 09 Dec 2017 07:05:55 -0000

ros-ardent-class-loader (0.3.2-13xenial) xenial; urgency=high

  * Fixed wrong handling of false statement (pkg-config was not installed)
  * Make catkin optional again
  * Contributors: Esteve Fernandez, Janosch Machowinski, Matthias Goldhoorn

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 22 Apr 2015 07:00:00 -0000

ros-ardent-class-loader (0.3.1-13xenial) xenial; urgency=high

  * Depend on boost
  * Use FindPoco.cmake from ros/cmake_modules
  * Honor BUILD_SHARED_LIBS and do not force building shared libraries.
  * Contributors: Esteve Fernandez, Gary Servin, Scott K Logan

 -- Esteve Fernandez <esteve@osrfoundation.org>  Tue, 23 Dec 2014 08:00:00 -0000

ros-ardent-class-loader (0.3.0-13xenial) xenial; urgency=high

  * Use system-provided console-bridge
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 25 Jun 2014 07:00:00 -0000

ros-ardent-class-loader (0.2.5-13xenial) xenial; urgency=high

  * Changed format of debug messages so that rosconsole_bridge can correctly parse the prefix
  * Improved debug output

 -- Esteve Fernandez <esteve@osrfoundation.org>  Tue, 04 Mar 2014 08:00:00 -0000

ros-ardent-class-loader (0.2.4-13xenial) xenial; urgency=high

  * fix race condition with multi threaded library loading (#16 <https://github.com/ros/class_loader/issues/16>)

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 12 Feb 2014 08:00:00 -0000

ros-ardent-class-loader (0.2.3-13xenial) xenial; urgency=high

  * fix missing class name in logWarn output

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 21 Aug 2013 07:00:00 -0000

ros-ardent-class-loader (0.2.2-13xenial) xenial; urgency=high

  * check for CATKIN_ENABLE_TESTING (#10 <https://github.com/ros/class_loader/issues/10>)
  * fix find Poco to return full lib path (#8 <https://github.com/ros/class_loader/issues/8>)
  * add missing runtime destination for library under Windows
  * add Boosst component system

 -- Esteve Fernandez <esteve@osrfoundation.org>  Sun, 14 Jul 2013 07:00:00 -0000

ros-ardent-class-loader (0.2.1-13xenial) xenial; urgency=high

  * improve check for Poco foundation and headers (#7 <https://github.com/ros/class_loader/issues/7>)

 -- Esteve Fernandez <esteve@osrfoundation.org>  Thu, 06 Jun 2013 07:00:00 -0000

ros-ardent-class-loader (0.2.0-13xenial) xenial; urgency=high

  * use find_package for Poco/dl instead to make it work on other platforms
  * update Poco cmake file to include libdl on non-windows systems
  * No longer CATKIN_DEPEND on console_bridge

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 13 Mar 2013 07:00:00 -0000

ros-ardent-class-loader (0.1.27-13xenial) xenial; urgency=high

  * change warning message for managed/unmanaged instance mixture in lazy loading mode

 -- Esteve Fernandez <esteve@osrfoundation.org>  Fri, 25 Jan 2013 08:00:00 -0000

ros-ardent-class-loader (0.1.26-13xenial) xenial; urgency=high

  * fix all instances marked as unmanaged

 -- Esteve Fernandez <esteve@osrfoundation.org>  Thu, 17 Jan 2013 08:00:00 -0000

ros-ardent-class-loader (0.1.25-13xenial) xenial; urgency=high

  * fix redundant destructor definition being pulled into plugin library for metaobjects instead of being contained with libclass_loader.so

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 16 Jan 2013 08:00:00 -0000

ros-ardent-class-loader (0.1.24-13xenial) xenial; urgency=high

  * fix syntax error for logInform

 -- Esteve Fernandez <esteve@osrfoundation.org>  Mon, 14 Jan 2013 23:27:00 -0000

ros-ardent-class-loader (0.1.23-13xenial) xenial; urgency=high

  * downgrade some warning messages to be info/debug

 -- Esteve Fernandez <esteve@osrfoundation.org>  Mon, 14 Jan 2013 23:23:00 -0000

ros-ardent-class-loader (0.1.22-13xenial) xenial; urgency=high

  * add safety checks for mixing of managed/unmanaged mixing as well as pointer equivalency check between graveyard and newly created metaobjects

 -- Esteve Fernandez <esteve@osrfoundation.org>  Mon, 14 Jan 2013 23:01:00 -0000

ros-ardent-class-loader (0.1.21-13xenial) xenial; urgency=high

  * fix compile issue on OSX in dependent packages (#3 <https://github.com/ros/class_loader/issues/3>)
  * add more debug information

 -- Esteve Fernandez <esteve@osrfoundation.org>  Sun, 13 Jan 2013 08:00:00 -0000

ros-ardent-class-loader (0.1.20-13xenial) xenial; urgency=high

  * first public release for Groovy

 -- Esteve Fernandez <esteve@osrfoundation.org>  Sat, 22 Dec 2012 00:04:00 -0000

=== debian/control ===
Source: ros-ardent-class-loader
Section: misc
Priority: extra
Maintainer: Mikael Arguedas <mikael@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libpoco-dev, ros-ardent-ament-cmake, ros-ardent-ament-cmake-gtest, ros-ardent-console-bridge, ros-ardent-poco-vendor, ros-ardent-ros-workspace
Homepage: http://ros.org/wiki/class_loader
Standards-Version: 3.9.2

Package: ros-ardent-class-loader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpoco-dev, ros-ardent-console-bridge, ros-ardent-poco-vendor, ros-ardent-ros-workspace
Description: The class_loader package is a ROS-independent package for loading plugins during runtime and the foundation of the higher level ROS &quot;pluginlib&quot; library.
 class_loader utilizes the host operating system's runtime loader to open runtime libraries (e.g. .so/.dll files), introspect the library for exported plugin classes, and allows users to instantiate objects of these exported classes without the explicit declaration (i.e. header file) for those classes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/ardent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/ardent/setup.sh" ]; then . "/opt/ros/ardent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/ardent" \
		-DAMENT_PREFIX_PATH="/opt/ros/ardent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/ardent/setup.sh" ]; then . "/opt/ros/ardent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/ardent/setup.sh" ]; then . "/opt/ros/ardent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/ardent/setup.sh" ]; then . "/opt/ros/ardent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-ardent-class-loader//opt/ros/ardent/lib/:$(CURDIR)/debian/ros-ardent-class-loader//opt/ros/ardent/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/:/opt/ros/ardent/lib/:/opt/ros/ardent/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/ardent/setup.sh" ]; then . "/opt/ros/ardent/setup.sh"; fi && \
	dh_auto_install
